Game = class("Game"):include(Stateful)


function Game:initialize()
  self:gotoState("Menu") -- start on the Menu state
end

local Menu = Game:addState("Menu")
local Play = Game:addState("Play")
local Play2 = Game:addState("Play2")

function Menu:enteredState() -- create buttons, options, etc and store them into self
--Le Font
pixelfont = love.graphics.newFont ('fonts/PressStart2P.ttf', 11)
headerfont = love.graphics.newFont ('fonts/PressStart2P.ttf', 35)
--Le Images
singleplayer = love.graphics.newImage('images/p1.png')
multiplayer = love.graphics.newImage('images/p2.png')
--Le Background
bg = love.graphics.newImage('images/bg.jpg')

--Selector variables for state 1
s_x = 200
s_y = 250
s_w = 130
s_h = 125
s_state = 1
end

function Menu:draw() -- draw the menu
love.graphics.setColor(255, 255, 255)
love.graphics.setFont(pixelfont)
love.graphics.draw( bg )
love.graphics.setColor(0, 0, 0)

love.graphics.rectangle ("line" , s_x ,s_y ,s_w ,s_h)

love.graphics.print ("Singleplayer", 200, 230)
love.graphics.print ("Multiplayer", 400, 230)

if won == "player1" then
love.graphics.print ("Player 1 won the last game.", 260, 530)
end

if won == "player2" then
love.graphics.print ("Player 2 won the last game.", 260, 530)
end

if won == "com" then
love.graphics.print ("Computer won the last game.", 260, 530)
end

love.graphics.setFont(headerfont)
love.graphics.print ("Pong", 300, 100)

love.graphics.setColor(255, 255, 255)
love.graphics.draw ( singleplayer , 200 , 250)
love.graphics.draw ( multiplayer , 400 , 250)
end

function Menu:update(dt) -- update anything that needs updates

if love.keyboard.isDown("d") or love.keyboard.isDown("right") and s_state == 1 then
s_state = 2
s_x = 400
s_y = 250
s_w = 250
s_h = 125
end

if love.keyboard.isDown("a") or love.keyboard.isDown("left") and s_state == 2 then
s_x = 200
s_y = 250
s_w = 130
s_h = 125
s_state = 1
end

if love.keyboard.isDown("return") then

if s_state == 1 then
game:gotoState("Play")
end

if s_state == 2 then
game:gotoState("Play2")
end

end

end

function Menu:exitedState() -- destroy buttons, options etc here
end

function Play:enteredState()
--Le Font
pixelfont = love.graphics.newFont ('fonts/PressStart2P.ttf', 10)
bigpixelfont = love.graphics.newFont ('fonts/PressStart2P.ttf', 50)
--Le Background
bg = love.graphics.newImage('images/bg.jpg')
pimage = love.graphics.newImage('images/p.png')
ballimage = love.graphics.newImage('images/ball.png')
--Global player Variables
playerheight = 70
playerwidth = 20
paddlespeed = 240
ballspeed = 240
-- Player Variables
p = {}
p.one = {}
p.one.x = 0
p.one.y = 300
p.one.w = playerwidth
p.one.h = playerheight

p.two = {}
p.two.x = 780
p.two.y = 300
p.two.w = playerwidth
p.two.h = playerheight

ball = {}
ball.w = 25
ball.h = 25
ball.x = 400
ball.y = 300

initialdir = "right"
initialvdir = "down"
dir = "Whatever"

player1score = 0
player2score = 0
scoredyet = "false"
end

function Play:update(dt)

random = math.random()

--init direction check
if initialdir == "right" then
ball.x = ball.x + 175 * dt
end

if initialcdir == "down" then
ball.y = ball.y + ballspeed * dt
end

--Check for collisions and invert the movement
if ball.x >= 755  and ball.y+ball.h >= p.two.y  and ball.y < p.two.y+p.two.h then
initialdir = "false"
dir = "left"
	if random >= 0.5 then
	vdir = "down"
	else
	vdir = "up"
	end
end

if ball.x <= 20 and ball.y+ball.h >= p.one.y and ball.y < p.one.y+p.one.h then
dir = "right"

	if random <= 0.5 then
	vdir = "up"
	else
	vdir = "down"
	end
end

--Collision with Y Screen bound
if ball.y >= 575 then
vdir = "up"
end

if ball.y <= 25 then 
vdir = "down"
end

--Check for the dir and calculate the movement
if dir == "left" then
ball.x = ball.x - ballspeed * dt
end

if dir == "right" then
ball.x = ball.x + ballspeed * dt
end

if vdir == "up" then
ball.y = ball.y - ballspeed * dt
end

if vdir == "down" then
ball.y = ball.y + ballspeed * dt
end

--Paddle movement
if love.keyboard.isDown("w") then
	if p.one.y > 0  then
	p.one.y = p.one.y - paddlespeed * dt
	end
end

if love.keyboard.isDown("s") then
	if  p.one.y+p.one.h < 600 then
p.one.y = p.one.y + paddlespeed * dt
end
end

--Pallde 2 "AI"
p.two.y = ball.y

--Let's make the score calculation, shall we?
if ball.x < 0  and scoredyet == "false" then
player2score = player2score + 1
scoredyet = "true"
BallReset()
	if player2score == 5 then 
	game:gotoState("Menu")
	won = "com"
	end
end

if ball.x > 800 and scoredyet == "false" then
player1score = player1score + 1
scoredyet = "true"
BallReset()
	if player1score == 5 then 
	game:gotoState("Menu")
	won = "player1"
	end
end

--Exit to Menu
if love.keyboard.isDown("escape") then
game:gotoState("Menu")

end

end

function Play:draw()
--Draw the Background via image
love.graphics.draw( bg )
love.graphics.setFont(bigpixelfont)
--Print the Score
love.graphics.print(""..player1score, 375,10)
love.graphics.print(""..player2score, 425,10)

-- Draw the Player

--PNG Version
love.graphics.draw(pimage, p.one.x,p.one.y)
love.graphics.draw(pimage, p.two.x,p.two.y)

--Old Rectangle Verson
-- love.graphics.rectangle ("fill", p.one.x, p.one.y, p.one.w, p.one.h)
-- love.graphics.rectangle ("fill", p.two.x, p.two.y, p.two.w, p.two.h)

-- The Ball

--Le Old version
-- love.graphics.rectangle ("fill", ball.x, ball.y, ball.w, ball.h)

love.graphics.draw(ballimage, ball.x,ball.y)
end

function Play2:exitedState() -- destroy buttons, options etc here
end

function Play2:enteredState()
--Le Font
pixelfont = love.graphics.newFont ('fonts/PressStart2P.ttf', 10)
bigpixelfont = love.graphics.newFont ('fonts/PressStart2P.ttf', 50)
--Le Background
bg = love.graphics.newImage('images/bg.jpg')
pimage = love.graphics.newImage('images/p.png')
ballimage = love.graphics.newImage('images/ball.png')
--Global player Variables
playerheight = 70
playerwidth = 20
paddlespeed = 240
ballspeed = 240
-- Player Variables
p = {}
p.one = {}
p.one.x = 0
p.one.y = 300
p.one.w = playerwidth
p.one.h = playerheight

p.two = {}
p.two.x = 780
p.two.y = 300
p.two.w = playerwidth
p.two.h = playerheight

ball = {}
ball.w = 25
ball.h = 25
ball.x = 400
ball.y = 300

initialdir = "right"
initialvdir = "down"
dir = "Whatever"

player1score = 0
player2score = 0
scoredyet = "false"
end

function Play2:update(dt)

random = math.random()

--init direction check
if initialdir == "right" then
ball.x = ball.x + 175 * dt
end

if initialcdir == "down" then
ball.y = ball.y + ballspeed * dt
end

--Check for collisions and invert the movement
if ball.x >= 755  and ball.y+ball.h >= p.two.y  and ball.y < p.two.y+p.two.h then
initialdir = "false"
dir = "left"
	if random >= 0.5 then
	vdir = "down"
	else
	vdir = "up"
	end
end

if ball.x <= 20 and ball.y+ball.h >= p.one.y and ball.y < p.one.y+p.one.h then
dir = "right"

	if random <= 0.5 then
	vdir = "up"
	else
	vdir = "down"
	end
end

--Collision with Y Screen bound
if ball.y >= 575 then
vdir = "up"
end

if ball.y <= 25 then 
vdir = "down"
end

--Check for the dir and calculate the movement
if dir == "left" then
ball.x = ball.x - ballspeed * dt
end

if dir == "right" then
ball.x = ball.x + ballspeed * dt
end

if vdir == "up" then
ball.y = ball.y - ballspeed * dt
end

if vdir == "down" then
ball.y = ball.y + ballspeed * dt
end

--Paddle movement
if love.keyboard.isDown("w") then
	if p.one.y > 0  then
	p.one.y = p.one.y - paddlespeed * dt
	end
end

if love.keyboard.isDown("s") then
	if  p.one.y+p.one.h < 600 then
	p.one.y = p.one.y + paddlespeed * dt
	end
end

if love.keyboard.isDown("up") then
	if p.two.y > 0  then
	p.two.y = p.two.y - paddlespeed * dt
	end
end

if love.keyboard.isDown("down") then
	if  p.two.y+p.two.h < 600 then
	p.two.y = p.two.y + paddlespeed * dt
	end
end



--Let's make the score calculation, shall we?
if ball.x < 0  and scoredyet == "false" then
player2score = player2score + 1
scoredyet = "true"
BallReset()
	if player2score == 5 then 
	game:gotoState("Menu")
	won = "player2"
	end
end

if ball.x > 800 and scoredyet == "false" then
player1score = player1score + 1
scoredyet = "true"
BallReset()
	if player1score == 5 then 
	game:gotoState("Menu")
	won = "player1"
	end
end

--Exit to Menu
if love.keyboard.isDown("escape") then
game:gotoState("Menu")


end


end

function Play2:draw()
--Draw the Background via image
love.graphics.draw( bg )
love.graphics.setFont(bigpixelfont)
--Print the Score
love.graphics.print(""..player1score, 375,10)
love.graphics.print(""..player2score, 425,10)

-- Draw the Player

--PNG Version
love.graphics.draw(pimage, p.one.x,p.one.y)
love.graphics.draw(pimage, p.two.x,p.two.y)

--Old Rectangle Verson
-- love.graphics.rectangle ("fill", p.one.x, p.one.y, p.one.w, p.one.h)
-- love.graphics.rectangle ("fill", p.two.x, p.two.y, p.two.w, p.two.h)

-- The Ball

--Le Old version
-- love.graphics.rectangle ("fill", ball.x, ball.y, ball.w, ball.h)

love.graphics.draw(ballimage, ball.x,ball.y)
end

function Play2:exitedState() -- destroy buttons, options etc here
end

function BallReset()
ball.x = 400
ball.y = 300
scoredyet = "false"
end